#include <bits/stdc++.h>
#include "testlib.h"

int sum(std::string s) {
    int result = 0;
    for (char c : s) {
        result += c == '1';
    }
    return result;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    std::string s = inf.readToken();
    int n = s.size();
    
    auto check_outp = [&](auto& stream) {
        int val = stream.readInt();
        if (val == -1) {
            return -1;
        }
        int l1 = val;
        if (l1 < 1 || l1 > n) {
            stream.quitf(_wa, "wrong left border of first segment (%d)", l1);
        }
        int r1 = stream.readInt(l1, n);
        int l2 = stream.readInt(1, n);
        int r2 = stream.readInt(l2, n);
        if (r1 - l1 != r2 - l2) {
            stream.quitf(_wa, "[%d, %d] and [%d, %d] have different lengths", l1, r1, l2, r2);
        }
        if (l1 == l2 && r1 == r2) {
            stream.quitf(_wa, "segments are equal");
        }
        int sum1 = sum(s.substr(l1 - 1, r1 - l1 + 1));
        int sum2 = sum(s.substr(l2 - 1, r2 - l2 + 1));
        if (sum1 != sum2) {
            stream.quitf(_wa, "sum(s[%d..%d]) != sum(s[%d..%d])", l1, r1, l2, r2);
        }
        return r1 - l1 + 1;
    };
    
    int plen = check_outp(ouf);
    int jlen = check_outp(ans);
    if (plen == -1 && jlen == -1) {
        quitf(_ok, "such two segments don't exist");
    }
    
    if (plen == -1) {
        quitf(_wa, "participant didn't find two segments but they exist");
    }
    
    if (jlen == -1) {
        quitf(_fail, "jury didn't find two segments but they exist");
    }
    
    if (plen < jlen) {
        quitf(_wa, "participant's length is not maximal possible");
    }
    
    if (plen > jlen) {
        quitf(_fail, "participant has found better answer than jury");
    }
    
    quitf(_ok, "correct segments of length %d", plen);
    return 0;
}
