#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct point {
	int x, y;

	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	double len() const {
		return sqrt((ll) x * x + (ll) y * y);
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

ll scalar(point const& p1, point const& p2) {
	return (ll) p1.x * p2.x + (ll) p1.y * p2.y;
}

double get_dist(point const& a, point const& b, point const& c) {
	if (scalar(b - a, c - a) < 0 || scalar(a - b, c - b) < 0) {
		return min((c - a).len(), (c - b).len());
	}
	return abs(cross(b - a, c - a) / (b - a).len());
}

ostream& operator<<(ostream& o, point const& p) {
	o << "(" << p.x << ", " << p.y << ")";
	return o;
}

double get_dist(vector<point> const& poly1, vector<point> const& poly2) {
	int c1 = 0, c2 = 0;
	point cur = poly1[0] + poly2[0];
	double ans = 1e100;
	while (c1 < szof(poly1) || c2 < szof(poly2)) {
		point shift(0, 0);
		int next1 = c1 + 1;
		if (next1 == szof(poly1)) {
			next1 = 0;
		}
		int next2 = c2 + 1;
		if (next2 == szof(poly2)) {
			next2 = 0;
		}

		if (c1 == szof(poly1) || (c2 != szof(poly2) && cross(poly1[next1] - poly1[c1], poly2[next2] - poly2[c2]) < 0)) {
			shift = poly2[next2] - poly2[c2];
			c2++;
		} else {
			shift = poly1[next1] - poly1[c1];
			c1++;
		}
		ans = min(ans, get_dist(cur, cur + shift, point(0, 0)));
		// cerr << cur << endl;
		cur = cur + shift;
	}
	return ans;
}

void solve() {
	int n, a, b;
	cin >> n >> a >> b;
	--a; --b;
	vector<vector<double>> graph(n, vector<double>(n));
	vector<vector<point>> polys;
	vector<vector<point>> ipolys;
	for (int i = 0; i < n; ++i) {
		polys.push_back({});
		ipolys.push_back({});
		int k;
		cin >> k;
		int mem = 0;
		for (int j = 0; j < k; ++j) {
			int x, y;
			cin >> x >> y;
			polys.back().push_back(point(x, y));
			ipolys.back().push_back(point(-x, -y));
			if (polys[i][j] < polys[i][mem]) {
				mem = j;
			}
		}
		rotate(polys[i].begin(), polys[i].begin() + mem, polys[i].end());
		mem = 0;
		for (int j = 0; j < k; ++j) {
			if (ipolys[i][j] < ipolys[i][mem]) {
				mem = j;
			}
		}
		rotate(ipolys[i].begin(), ipolys[i].begin() + mem, ipolys[i].end());
	}

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			graph[i][j] = graph[j][i] = get_dist(polys[i], ipolys[j]);
		}
	}

	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < n; ++j) {
	// 		cerr << graph[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }

	vector<double> dist(n, 1e100);
	dist[a] = 0;
	vector<bool> used(n);

	for (int i = 0; i < n; ++i) {
		int mem = -1;
		for (int j = 0; j < n; ++j) {
			if (!used[j]) {
				if (mem == -1 || dist[mem] > dist[j]) {
					mem = j;
				}
			}
		}

		// cerr << dist[mem] << " " << mem << endl;

		used[mem] = true;
		if (mem == b) {
			cout << dist[b] << "\n";
			return;
		}
		for (int j = 0; j < n; ++j) {
			dist[j] = min(dist[j], dist[mem] + graph[mem][j]);
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
