#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

double sqr(double num) {
	return num * num;
}

double get_dist(double x1, double y1, double x2, double y2) {
	return sqrt(sqr(x1 - x2) + sqr(y1 - y2));
}

struct point {
	int x, y;

	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	double len() const {
		return sqrt((ll) x * x + (ll) y * y);
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

ll scalar(point const& p1, point const& p2) {
	return (ll) p1.x * p2.x + (ll) p1.y * p2.y;
}

double get_dist(point const& a, point const& b, point const& c) {
	if (scalar(b - a, c - a) < 0 || scalar(a - b, c - b) < 0) {
		return min((c - a).len(), (c - b).len());
	}
	return abs(cross(b - a, c - a) / (b - a).len());
}

void solve() {
	int n, a, b;
	cin >> n >> a >> b;
	--a; --b;
	vector<vector<point>> polys;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		polys.push_back({});
		for (int j = 0; j < k; ++j) {
			int x, y;
			cin >> x >> y;
			polys.back().push_back(point(x, y));
		}
	}

	vector<vector<double>> dist(n, vector<double>(n, 1e100));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i == j) {
				continue;
			}
			double val = dist[i][j];
			for (int a = 0; a < szof(polys[i]); ++a) {
				for (int b = 0; b < szof(polys[j]); ++b) {
					int next = (b + 1) % szof(polys[j]);
					double cur = get_dist(polys[j][b], polys[j][next], polys[i][a]);
					val = min(val, cur);
				}
			}

			dist[i][j] = dist[j][i] = val;
		}
	}

	vector<double> d(n, 1e100);
	d[a] = 0;
	set<pair<double, int>> st;
	st.insert({0, a});
	while (szof(st)) {
		int v = st.begin()->ss;
		st.erase(st.begin());
		for (int i = 0; i < n; ++i) {
			double val = d[v] + dist[v][i];
			if (d[i] > val) {
				st.erase({d[i], i});
				d[i] = val;
				st.insert({d[i], i});
			}
		}
	}

	cout << d[b] << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
