#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct point {
	int x, y;

	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator-() const {
		return point(-x, -y);
	}

	double len() const {
		return sqrt((ll) x * x + (ll) y * y);
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

ll scalar(point const& p1, point const& p2) {
	return (ll) p1.x * p2.x + (ll) p1.y * p2.y;
}

double get_dist(point const& a, point const& b, point const& c) {
	if (scalar(b - a, c - a) < 0 || scalar(a - b, c - b) < 0) {
		return min((c - a).len(), (c - b).len());
	}
	return abs(cross(b - a, c - a) / (b - a).len());
}

ostream& operator<<(ostream& o, point const& p) {
	o << "(" << p.x << ", " << p.y << ")";
	return o;
}

bool cmp(point const& p1, point const& p2) {
	bool fl1 = p1.x < 0 || (p1.x == 0 && p1.y < 0);
	bool fl2 = p2.x < 0 || (p2.x == 0 && p2.y < 0);
	if (fl1 != fl2) {
		return fl1 < fl2;
	}
	return cross(p1, p2) > 0;
}

double get_dist(vector<point> const& poly1, vector<point> poly2) {
	// for (auto& p : poly2) {
	// 	p = -p;
	// 	cerr << p.x << " " << p.y << endl;
	// }
	// cerr << endl;

	int mem = 0;
	vector<point> sides;
	for (int i = 0; i < szof(poly1); ++i) {
		int next = (i + 1) % szof(poly1);
		sides.push_back(poly1[next] - poly1[i]);
		if (poly1[i] < poly1[mem]) {
			mem = i;
		}
	}
	point cur = poly1[mem];

	mem = 0;
	for (int i = 0; i < szof(poly2); ++i) {
		int next = (i + 1) % szof(poly2);
		sides.push_back(poly2[next] - poly2[i]);
		if (poly2[i] < poly2[mem]) {
			mem = i;
		}
	}

	cur = cur + poly2[mem];

	sort(sides.begin(), sides.end(), cmp);

	double ret = 1e100;

	for (auto& p : sides) {
		point next = cur + p;
		ret = min(ret, get_dist(next, cur, point(0, 0)));
		cur = next;
	}
	return ret;
}

void solve() {
	int n, a, b;
	cin >> n >> a >> b;
	--a; --b;
	vector<vector<double>> graph(n, vector<double>(n));
	vector<vector<point>> polys;
	vector<vector<point>> ipolys;
	for (int i = 0; i < n; ++i) {
		polys.push_back({});
		ipolys.push_back({});
		int k;
		cin >> k;
		int mem = 0;
		for (int j = 0; j < k; ++j) {
			int x, y;
			cin >> x >> y;
			polys.back().push_back(point(x, y));
			ipolys.back().push_back(point(-x, -y));
			if (polys[i][j] < polys[i][mem]) {
				mem = j;
			}
		}
		rotate(polys[i].begin(), polys[i].begin() + mem, polys[i].end());
		mem = 0;
		for (int j = 0; j < k; ++j) {
			if (ipolys[i][j] < ipolys[i][mem]) {
				mem = j;
			}
		}
		rotate(ipolys[i].begin(), ipolys[i].begin() + mem, ipolys[i].end());
	}

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			graph[i][j] = graph[j][i] = get_dist(polys[i], ipolys[j]);
		}
	}

	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < n; ++j) {
	// 		cerr << graph[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }

	vector<double> dist(n, 1e100);
	dist[a] = 0;
	vector<bool> used(n);

	for (int i = 0; i < n; ++i) {
		int mem = -1;
		for (int j = 0; j < n; ++j) {
			if (!used[j]) {
				if (mem == -1 || dist[mem] > dist[j]) {
					mem = j;
				}
			}
		}

		// cerr << dist[mem] << " " << mem << endl;

		used[mem] = true;
		if (mem == b) {
			cout << dist[b] << "\n";
			return;
		}
		for (int j = 0; j < n; ++j) {
			dist[j] = min(dist[j], dist[mem] + graph[mem][j]);
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
