#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

double sqr(double num) {
	return num * num;
}

double get_dist(double x1, double y1, double x2, double y2) {
	return sqrt(sqr(x1 - x2) + sqr(y1 - y2));
}

void solve() {
	int n, a, b;
	cin >> n >> a >> b;
	--a; --b;
	vector<vector<pii>> polys;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		polys.push_back({});
		for (int j = 0; j < k; ++j) {
			int x, y;
			cin >> x >> y;
			polys.back().push_back({x, y});
		}
	}

	vector<vector<double>> dist(n, vector<double>(n, 1e100));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i == j) {
				continue;
			}
			double val = dist[i][j];
			for (int a = 0; a < szof(polys[i]); ++a) {
				for (int b = 0; b < szof(polys[j]); ++b) {
					int next = (b + 1) % szof(polys[j]);
					double l = 0, r = 1;
					for (int q = 0; q < 60; ++q) {
						double mid1 = (l * 2 + r) / 3;
						double mid2 = (l + r * 2) / 3;
						double dist1 = get_dist(polys[i][a].ff, polys[i][a].ss, polys[j][b].ff * mid1 + polys[j][next].ff * (1 - mid1), polys[j][b].ss * mid1 + polys[j][next].ss * (1 - mid1));
						double dist2 = get_dist(polys[i][a].ff, polys[i][a].ss, polys[j][b].ff * mid2 + polys[j][next].ff * (1 - mid2), polys[j][b].ss * mid2 + polys[j][next].ss * (1 - mid2));
						val = min(val, min(dist1, dist2));
						if (dist1 > dist2) {
							l = mid1;
						} else {
							r = mid2;
						}
					}
				}
			}

			dist[i][j] = dist[j][i] = val;
		}
	}

	vector<double> d(n, 1e100);
	d[a] = 0;
	set<pair<double, int>> st;
	st.insert({0, a});
	while (szof(st)) {
		int v = st.begin()->ss;
		st.erase(st.begin());
		for (int i = 0; i < n; ++i) {
			double val = d[v] + dist[v][i];
			if (d[i] > val) {
				st.erase({d[i], i});
				d[i] = val;
				st.insert({d[i], i});
			}
		}
	}

	cout << d[b] << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
