#include "testlib.h"

#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <ctime>
#include <climits>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <bitset>
#include <utility>
#include <algorithm>

using namespace std;

const int N = 5e5 + 7;
const int K = 20;

int h[N];
int st[N][K];

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int t = atoi(argv[3]);
    vector <int> par(n);
    vector <int> p(n);
    for (int i = 0; i < n; i++) p[i] = i;
    shuffle(p.begin(), p.end());
    vector <pair <int, int> > e;
    for (int i = 1; i < n; i++)
    {
      par[i] = rnd.wnext(0, i - 1, t);
      e.push_back({par[i], i});
      h[i] = h[par[i]] + 1;
      st[i][0] = par[i];
      for (int j = 1; j < K; j++)
      {
        st[i][j] = st[st[i][j - 1]][j - 1];
      }
    }
    for (int i = 0; i < m - (n - 1); i++)
    {
      int v = rnd.next(1, n - 1);
      int u = v;
      int kek = rnd.next(1, h[v]);
      for (int i = 0; i < K; i++)
      {
        if ((kek >> i) & 1)
        {
          u = st[u][i];
        }
      }
      e.push_back({u, v});
    }
    shuffle(e.begin(), e.end());
    cout << n << ' ' << m << '\n';
    for (auto c : e)
    {
      cout << p[c.first] + 1 << ' ' << p[c.second] + 1 << '\n';
    }
}
