#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> rgraph(n), graph(n);
	vector<int> out(n);
	set<pii> edges;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		out[a]++;
		edges.insert({a, b});
		rgraph[b].push_back(a);
		graph[a].push_back(b);
	}

	queue<int> qu;
	for (int i = 0; i < n; ++i) {
		if (out[i] == 0) {
			qu.push(i);
		}
	}

	vector<bool> used(n);
	vector<vector<int>> tree(n);
	int root = -1;

	for (int i = 0; i < n; ++i) {
		if (!szof(qu)) {
			cout << "No\n";
			return;
		}

		int v = qu.front();
		qu.pop();
		root = v;

		for (int to : graph[v]) {
			if (!used[to]) {
				tree[v].push_back(to);
				used[to] = true;
			}
		}

		for (int to : rgraph[v]) {
			--out[to];
			if (out[to] == 0) {
				qu.push(to);
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		if (!used[i] && i != root) {
			cout << "No\n";
			return;
		}
	}

	vector<int> tin(n), tout(n);
	int tcnt = 0;

	vector<int> st;

	function<void(int)> dfs = [&](int v) {
		st.push_back(v);
		tin[v] = tcnt++;
		for (int to : tree[v]) {
			dfs(to);
		}
		tout[v] = tcnt;
		st.pop_back();
	};

	dfs(root);
	for (pii e : edges) {
		if (!(tin[e.ff] <= tin[e.ss] && tout[e.ss] <= tout[e.ff])) {
			cout << "No\n";
			return;
		}
	}

	vector<int> parent(n, -1);
	for (int i = 0; i < n; ++i) {
		for (int to : tree[i]) {
			parent[to] = i + 1;
		}
	}

	cout << "Yes\n";

	for (int num : parent) {
		cout << num << " ";
	}
	cout << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
